<template>
  <div>
    <div
      v-if="loading"
      class="h-16 !relative !min-h-5 flex justify-center items-center"
    >
      <div class="animate-spin w-fit">
        <div class="custom-spinner" />
      </div>
    </div>
    <div v-else>
      <!-- Empty State -->
      <app-empty-state-cta
        v-if="!hasIntegrations && !hasMembers"
        icon="ri-contacts-line"
        title="No contacts yet"
        description="Please connect with one of our available data sources in order to start pulling data from a certain platform"
        cta-btn="Connect integrations"
        secondary-btn="Add contacts"
        @cta-click="onCtaClick"
        @secondary-click="onSecondaryBtnClick"
      />

      <app-empty-state-cta
        v-else-if="hasIntegrations && !hasMembers"
        icon="ri-contacts-line"
        title="No contacts yet"
        description="Please consider that the first contacts may take a couple of minutes to be displayed"
        :has-warning-icon="true"
      />

      <app-empty-state-cta
        v-else-if="hasMembers && !totalMembers"
        icon="ri-contacts-line"
        title="No contacts found"
        description="We couldn't find any results that match your search criteria, please try a different query"
      />

      <div v-else>
        <!-- Sorter -->
        <div class="mb-2">
          <app-pagination-sorter
            :page-size="Number(pagination.perPage)"
            :total="totalMembers"
            :current-page="pagination.page"
            :has-page-counter="false"
            :export="doExport"
            module="contact"
            position="top"
            @change-sorter="doChangePaginationPageSize"
          >
            <template #defaultFilters>
              <div>・</div>
              <cr-default-filters
                :config="memberSavedViews"
                :settings="filters.settings"
              />
            </template>
          </app-pagination-sorter>
        </div>

        <!-- Members list -->
        <div class="app-list-table panel">
          <transition name="el-fade-in">
            <div
              v-show="isScrollbarVisible"
              class="absolute z-20 top-0 left-0 w-full"
              @mouseover="onTableMouseover"
              @mouseleave="onTableMouseLeft"
            >
              <el-scrollbar
                id="custom-scrollbar"
                ref="scrollbarRef"
                height="10px"
                always
                @scroll="onCustomScrollbarScroll"
                @pointerdown="onScrollMousedown"
              >
                <div
                  :style="{
                    height: '10px',
                  }"
                />
              </el-scrollbar>
            </div>
          </transition>
          <app-member-list-toolbar
            @mouseover="onTableMouseover"
            @mouseleave="onTableMouseLeft"
          />
          <div
            class="-mx-6 -mt-6"
            @mouseover="onTableMouseover"
            @mouseleave="onTableMouseLeft"
          >
            <el-table
              id="members-table"
              ref="table"
              v-loading="loading"
              :data="members"
              :default-sort="defaultSort"
              row-key="id"
              border
              :row-class-name="rowClass"
              @sort-change="doChangeSort"
              @selection-change="selectedMembers = $event"
              @cell-mouse-enter="handleCellMouseEnter"
              @cell-mouse-leave="handleCellMouseLeave"
            >
              <el-table-column type="selection" width="75" :fixed="!isMobile" />

              <!-- Contacts -->
              <el-table-column
                label="Contact"
                prop="displayName"
                width="250"
                :fixed="!isMobile"
                class="-my-2"
                sortable="custom"
              >
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <div class="flex items-center text-black">
                      <app-avatar :entity="scope.row" size="sm" class="mr-2" />
                      <span
                        class="font-semibold"
                        data-qa="members-name"
                        v-html="$sanitize(scope.row.displayName)"
                      />
                      <app-member-sentiment :member="scope.row" class="ml-2" />
                      <app-member-badge :member="scope.row" />
                    </div>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Organization & Title -->
              <el-table-column label="Organization & Title" width="220">
                <template #header>
                  <div class="flex items-center">
                    <div class="mr-2">
                      Organization & Title
                    </div>
                    <el-tooltip content="Source: Enrichment & GitHub" placement="top" trigger="hover">
                      <app-svg name="source" class="h-3 w-3" />
                    </el-tooltip>
                  </div>
                </template>
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <app-member-organizations
                      :member="scope.row"
                      :show-title="true"
                    />
                  </router-link>
                </template>
              </el-table-column>

              <!-- Identities -->
              <el-table-column label="Identities" width="280">
                <template #header>
                  <span>Identities</span>
                  <el-tooltip placement="top">
                    <template #content>
                      Identities can be profiles on social platforms, emails, phone numbers,<br>
                      or unique identifiers from internal sources (e.g. web app log-in email).
                    </template>
                    <i class="ri-information-line text-xs ml-1" />
                  </el-tooltip>
                </template>
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <app-identities-horizontal-list-members
                      :member="scope.row"
                      :limit="5"
                    />
                  </router-link>
                </template>
              </el-table-column>

              <!-- Emails -->
              <el-table-column label="Emails" :width="emailsColumnWidth">
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <div
                      v-if="scope.row.emails.filter((e) => !!e)?.length && scope.row.emails.filter((e) => !!e)?.some((e) => !!e)"
                      class="text-sm cursor-auto flex flex-wrap gap-1"
                    >
                      <el-tooltip
                        v-for="email of scope.row.emails.filter((e) => !!e).slice(0, 3)"
                        :key="email"
                        :disabled="!email"
                        popper-class="custom-identity-tooltip"
                        placement="top"
                      >
                        <template #content>
                          <span>Send email
                            <i
                              v-if="email"
                              class="ri-external-link-line text-gray-400"
                            /></span>
                        </template>
                        <div @click.prevent>
                          <a
                            target="_blank"
                            rel="noopener noreferrer"
                            class="badge--interactive"
                            :href="`mailto:${email}`"
                            @click.stop="trackEmailClick"
                          >{{ email }}</a>
                        </div>
                      </el-tooltip>
                      <el-popover
                        v-if="scope.row.emails.filter((e) => !!e)?.length > 3"
                        placement="top"
                        :width="400"
                        trigger="hover"
                        popper-class="support-popover"
                      >
                        <template #reference>
                          <span
                            class="badge--interactive hover:text-gray-900"
                          >+{{ scope.row.emails.filter((e) => !!e).length - 3 }}</span>
                        </template>
                        <div class="flex flex-wrap gap-3 my-1">
                          <el-tooltip
                            v-for="email of scope.row.emails.filter((e) => !!e).slice(3)"
                            :key="email"
                            :disabled="!email"
                            popper-class="custom-identity-tooltip flex "
                            placement="top"
                          >
                            <template #content>
                              <span>Send email
                                <i
                                  v-if="email"
                                  class="ri-external-link-line text-gray-400"
                                /></span>
                            </template>
                            <div @click.prevent>
                              <a
                                target="_blank"
                                rel="noopener noreferrer"
                                class="badge--interactive"
                                :href="`mailto:${email}`"
                                @click.stop="trackEmailClick"
                              >{{ email }}</a>
                            </div>
                          </el-tooltip>
                        </div>
                      </el-popover>
                    </div>
                    <span v-else class="text-gray-500">-</span>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Engagement level -->
              <el-table-column
                label="Engagement Level"
                prop="score"
                width="210"
                sortable="custom"
              >
                <template #header>
                  <span>Engagement Level</span>
                  <el-tooltip placement="top">
                    <template #content>
                      Calculated based on the recency and importance of the activities<br>
                      a contact has performed in relation to all other contacts.
                      <br>E.g. a higher engagement level will be given to a contact who has written
                      <br>in your Slack yesterday vs. someone who did so three weeks ago.
                    </template>
                    <i class="ri-information-line text-xs ml-1" />
                  </el-tooltip>
                </template>
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <app-member-engagement-level :member="scope.row" />
                  </router-link>
                </template>
              </el-table-column>

              <!-- # of Activities -->
              <el-table-column
                label="# of Activities"
                prop="activityCount"
                width="200"
                sortable="custom"
              >
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block !text-gray-500"
                  >
                    {{ formatNumber(scope.row.activityCount) }}
                  </router-link>
                </template>
              </el-table-column>

              <!-- Last activity -->
              <el-table-column
                label="Last activity"
                prop="lastActive"
                width="250"
                sortable="custom"
              >
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block !text-gray-500"
                  >
                    <app-member-last-activity
                      v-if="scope.row.lastActivity"
                      :member="scope.row"
                    />
                  </router-link>
                </template>
              </el-table-column>

              <!-- Joined Date -->
              <el-table-column
                label="Joined Date"
                width="200"
                prop="joinedAt"
                sortable
              >
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <div
                      v-if="scope.row.joinedAt"
                      class="text-gray-900 text-sm"
                    >
                      {{ formatDateToTimeAgo(scope.row.joinedAt) }}
                    </div>
                    <span v-else class="text-gray-900">-</span>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Location -->
              <el-table-column
                label="Location"
                width="200"
              >
                <template #header>
                  <div class="flex items-center">
                    <div class="mr-2">
                      Location
                    </div>
                    <el-tooltip content="Source: Enrichment & GitHub" placement="top" trigger="hover">
                      <app-svg name="source" class="h-3 w-3" />
                    </el-tooltip>
                  </div>
                </template>
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <div
                      v-if="scope.row.attributes?.location?.default"
                      class="text-gray-900 text-sm"
                    >
                      {{ scope.row.attributes.location.default }}
                    </div>
                    <span v-else class="text-gray-900">-</span>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Reach -->
              <el-table-column
                v-if="showReach"
                label="Reach"
                prop="reach"
                width="180"
                sortable="custom"
              >
                <template #header>
                  <div
                    :ref="(el) => setEnrichmentAttributesRef(el, `reach`)"
                    class="inline-flex"
                    @mouseover="() => onColumnHeaderMouseOver('reach')"
                    @mouseleave="closeEnrichmentPopover"
                  >
                    <span :class="{ 'text-purple-400': !isEnrichEnabled }">Reach</span>
                    <div class="inline-flex items-center ml-1 gap-2">
                      <el-tooltip placement="top">
                        <template #content>
                          Reach is the combined followers across social platforms (e.g. GitHub or Twitter).
                        </template>
                        <i class="ri-information-line text-xs" />
                      </el-tooltip>
                      <el-tooltip content="Source: GitHub" placement="top" trigger="hover" :disabled="!isEnrichEnabled">
                        <app-svg name="source" class="h-3 w-3" />
                      </el-tooltip>
                    </div>
                  </div>
                </template>
                <template #default="scope">
                  <router-link
                    :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-reach`)"
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block h-full !text-gray-500"
                  >
                    <app-member-reach
                      v-if="isEnrichEnabled"
                      :member="{
                        ...scope.row,
                        reach: scope.row.reach,
                      }"
                    />
                    <div v-else class="flex items-center h-full w-full pl-3">
                      <div class="blur-[6px] text-gray-900 select-none">
                        150
                      </div>
                    </div>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Seniority Level -->
              <el-table-column
                label="Seniority Level"
                prop="seniorityLevel"
                width="200"
              >
                <template #header>
                  <div
                    :ref="(el) => setEnrichmentAttributesRef(el, `seniorityLevel`)"
                    class="flex items-center"
                    @mouseover="() => onColumnHeaderMouseOver('seniorityLevel')"
                    @mouseleave="closeEnrichmentPopover"
                  >
                    <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                      Seniority Level
                    </div>
                    <el-tooltip
                      content="Source: Enrichment"
                      placement="top"
                      trigger="hover"
                      :disabled="!isEnrichEnabled"
                    >
                      <app-svg name="source" class="h-3 w-3" />
                    </el-tooltip>
                  </div>
                </template>
                <template #default="scope">
                  <router-link
                    :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-seniorityLevel`)"
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block h-full"
                  >
                    <div v-if="isEnrichEnabled">
                      <div
                        v-if="scope.row.attributes?.seniorityLevel?.default"
                        class="text-gray-900 text-sm"
                      >
                        {{ scope.row.attributes.seniorityLevel.default }}
                      </div>
                      <span v-else class="text-gray-900">-</span>
                    </div>
                    <div v-else class="flex items-center h-full w-full pl-3">
                      <div class="blur-[6px] text-gray-900 select-none">
                        Senior
                      </div>
                    </div>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Programming Languages -->
              <el-table-column
                label="Programming Languages"
                prop="programmingLanguages"
                width="250"
              >
                <template #header>
                  <div
                    :ref="(el) => setEnrichmentAttributesRef(el, `programmingLanguagess`)"
                    class="flex items-center"
                    @mouseover="() => onColumnHeaderMouseOver('programmingLanguagess')"
                    @mouseleave="closeEnrichmentPopover"
                  >
                    <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                      Programming Languages
                    </div>
                    <el-tooltip
                      content="Source: Enrichment"
                      placement="top"
                      trigger="hover"
                      :disabled="!isEnrichEnabled"
                    >
                      <app-svg name="source" class="h-3 w-3" />
                    </el-tooltip>
                  </div>
                </template>
                <template #default="scope">
                  <router-link
                    :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-programmingLanguages`)"
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block h-full"
                  >
                    <div v-if="isEnrichEnabled">
                      <app-shared-tag-list
                        v-if="scope.row.attributes.programmingLanguages?.default?.length"
                        :list="scope.row.attributes.programmingLanguages.default"
                        :slice-size="5"
                      >
                        <template #itemSlot="{ item }">
                          <span class="border border-gray-200 px-2.5 text-xs rounded-md h-6 text-gray-900 inline-flex break-keep">
                            {{ item }}
                          </span>
                        </template>
                      </app-shared-tag-list>
                      <span v-else class="text-gray-500">-</span>
                    </div>
                    <div v-else class="flex items-center h-full w-full pl-3">
                      <div class="blur-[6px] text-gray-900 select-none">
                        Javascript, Java
                      </div>
                    </div>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Skills -->
              <el-table-column
                label="Skills"
                prop="skills"
                width="250"
              >
                <template #header>
                  <div
                    :ref="(el) => setEnrichmentAttributesRef(el, `skills`)"
                    class="flex items-center"
                    @mouseover="() => onColumnHeaderMouseOver('skills')"
                    @mouseleave="closeEnrichmentPopover"
                  >
                    <div class="mr-2" :class="{ 'text-purple-400': !isEnrichEnabled }">
                      Skills
                    </div>
                    <el-tooltip
                      content="Source: Enrichment"
                      placement="top"
                      trigger="hover"
                      :disabled="!isEnrichEnabled"
                    >
                      <app-svg name="source" class="h-3 w-3" />
                    </el-tooltip>
                  </div>
                </template>
                <template #default="scope">
                  <router-link
                    :ref="(el) => setEnrichmentAttributesRef(el, `${scope.row.id}-skills`)"
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block h-full"
                  >
                    <div v-if="isEnrichEnabled">
                      <app-shared-tag-list
                        v-if="scope.row.attributes.skills?.default?.length"
                        :list="scope.row.attributes.skills.default"
                        :slice-size="5"
                      >
                        <template #itemSlot="{ item }">
                          <span class="border border-gray-200 px-2.5 text-xs rounded-md h-6 text-gray-900 inline-flex break-keep">
                            {{ item }}
                          </span>
                        </template>
                      </app-shared-tag-list>
                      <span v-else class="text-gray-500">-</span>
                    </div>
                    <div v-else class="flex items-center h-full w-full pl-3">
                      <div class="blur-[6px] text-gray-900 select-none">
                        Web development
                      </div>
                    </div>
                  </router-link>
                </template>
              </el-table-column>

              <!-- Tags -->
              <el-table-column
                :width="tagsColumnWidth"
                :label="translate('entities.member.fields.tag')"
              >
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block"
                  >
                    <app-tag-list :member="scope.row" @edit="handleEditTagsDialog(scope.row)" />
                  </router-link>
                </template>
              </el-table-column>

              <!-- Action button -->
              <el-table-column :fixed="!isMobile && 'right'">
                <template #default="scope">
                  <router-link
                    :to="{
                      name: 'memberView',
                      params: { id: scope.row.id },
                    }"
                    class="block w-full"
                  >
                    <div class="h-full flex items-center justify-center w-full">
                      <button
                        :id="`buttonRef-${scope.row.id}`"
                        :ref="(el) => setActionBtnsRef(el, scope.row.id)"
                        class="el-dropdown-link btn p-1.5 rounder-md hover:bg-gray-200 text-gray-600"
                        type="button"
                        @click.prevent.stop="() => onActionBtnClick(scope.row)"
                      >
                        <i
                          :id="`buttonRefIcon-${scope.row.id}`"
                          class="text-xl ri-more-fill"
                        />
                      </button>
                    </div>
                  </router-link>
                </template>
              </el-table-column>
            </el-table>

            <div v-if="!!totalMembers" class="mt-8 px-6">
              <app-pagination
                :total="totalMembers"
                :page-size="Number(pagination.perPage)"
                :current-page="pagination.page || 1"
                module="contact"
                @change-current-page="doChangePaginationCurrentPage"
                @change-page-size="doChangePaginationPageSize"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- Actions dropdown popover -->
    <el-popover
      placement="bottom-end"
      popper-class="popover-dropdown"
      :virtual-ref="actionBtnRefs[selectedActionMember?.id]"
      trigger="click"
      :visible="showMemberDropdownPopover"
      virtual-triggering
    >
      <div v-click-outside="onClickOutside">
        <app-member-dropdown-content
          v-if="selectedActionMember"
          :member="selectedActionMember"
          :hide-unmerge="true"
          @find-github="isFindGithubDrawerOpen = selectedActionMember"
          @merge="isMergeDialogOpen = selectedActionMember"
          @close-dropdown="closeDropdown"
        />
      </div>
    </el-popover>

    <!-- Enrichment popover -->
    <el-popover
      v-if="!isEnrichEnabled"
      placement="top"
      popper-class="!p-0 !mb-[-12px] !w-60"
      :virtual-ref="enrichmentRefs[selectedEnrichmentAttribute]"
      trigger="hover"
      :visible="showEnrichmentPopover"
      virtual-triggering
      @hide="onHide"
    >
      <cr-enrichment-sneak-peak-content id="popover-content" type="contact" @mouseleave="closeEnrichmentPopover" />
    </el-popover>

    <app-member-find-github-drawer
      v-if="isFindGithubDrawerOpen"
      v-model="isFindGithubDrawerOpen"
    />
    <app-member-merge-dialog v-model="isMergeDialogOpen" />
    <app-tag-popover v-model="isEditTagsDialogOpen" :member="editTagMember" @reload="fetchMembers({ reload: true })" />
  </div>
</template>

<script setup>
import { useStore } from 'vuex';
import { useRouter } from 'vue-router';
import {
  computed, onMounted, onUnmounted, ref, defineProps, watch,
} from 'vue';
import { ClickOutside as vClickOutside } from 'element-plus';
import { storeToRefs } from 'pinia';
import { i18n } from '@/i18n';
import AppMemberListToolbar from '@/modules/member/components/list/member-list-toolbar.vue';
import AppMemberOrganizations from '@/modules/member/components/member-organizations.vue';
import AppTagList from '@/modules/tag/components/tag-list.vue';
import { formatDateToTimeAgo } from '@/utils/date';
import { formatNumber } from '@/utils/number';
import { useMemberStore } from '@/modules/member/store/pinia';
import { MemberService } from '@/modules/member/member-service';
import AppMemberMergeDialog from '@/modules/member/components/member-merge-dialog.vue';
import AppTagPopover from '@/modules/tag/components/tag-popover.vue';
import AppPagination from '@/shared/pagination/pagination.vue';
import AppMemberFindGithubDrawer from '@/modules/member/components/member-find-github-drawer.vue';
import AppSharedTagList from '@/shared/tag/tag-list.vue';
import AppSvg from '@/shared/svg/svg.vue';
import CrEnrichmentSneakPeakContent from '@/shared/modules/enrichment/components/enrichment-sneak-peak-content.vue';
import { mapGetters } from '@/shared/vuex/vuex.helpers';
import Plans from '@/security/plans';
import AppIdentitiesHorizontalListMembers from '@/shared/modules/identities/components/identities-horizontal-list-members.vue';
import CrDefaultFilters from '@/shared/modules/default-filters/components/default-filters.vue';
import AppMemberBadge from '../member-badge.vue';
import AppMemberDropdownContent from '../member-dropdown-content.vue';
import AppMemberReach from '../member-reach.vue';
import AppMemberEngagementLevel from '../member-engagement-level.vue';
import AppMemberLastActivity from '../member-last-activity.vue';
import AppMemberSentiment from '../member-sentiment.vue';
import { memberSavedViews } from '../../config/saved-views/main';

const store = useStore();
const router = useRouter();
const table = ref(null);
const scrollbarRef = ref();
const tableBodyRef = ref();
const tableHeaderRef = ref();
const isScrollbarVisible = ref(false);
const isTableHovered = ref(false);
const isCursorDown = ref(false);

const isMergeDialogOpen = ref(null);
const isEditTagsDialogOpen = ref(false);
const editTagMember = ref(null);

const showMemberDropdownPopover = ref(false);
const actionBtnRefs = ref({});
const selectedActionMember = ref(null);

const showEnrichmentPopover = ref(false);
const enrichmentRefs = ref({});
const selectedEnrichmentAttribute = ref(null);

const isFindGithubDrawerOpen = ref(null);

const props = defineProps({
  hasIntegrations: {
    type: Boolean,
    default: () => false,
  },
  hasMembers: {
    type: Boolean,
    default: () => false,
  },
  isPageLoading: {
    type: Boolean,
    default: () => true,
  },
  pagination: {
    type: Object,
    default: () => ({
      page: 1,
      perPage: 20,
    }),
  },
});

const emit = defineEmits(['update:pagination']);

const memberStore = useMemberStore();
const {
  members, totalMembers, filters, selectedMembers, savedFilterBody,
} = storeToRefs(memberStore);

const { fetchMembers } = memberStore;

const { currentTenant } = mapGetters('auth');

const isEnrichEnabled = computed(() => currentTenant.value?.plan !== Plans.values.starter);

const defaultSort = computed(() => ({
  prop: 'lastActive',
  order: 'descending',
}));

const isMobile = computed(() => store.getters['layout/isMobile']);

const integrations = computed(
  () => store.getters['integration/activeList'] || {},
);

const showReach = computed(
  () => integrations.value.twitter?.status === 'done'
    || integrations.value.github?.status === 'done',
);

const loading = computed(
  () => props.isPageLoading,
);

const tagsColumnWidth = computed(() => {
  let maxTabWidth = 0;
  members.value.forEach((row) => {
    if (row.tags) {
      const tabWidth = row.tags
        .map((tag) => tag.name.length * 20)
        .reduce((a, b) => a + b, 0);

      if (tabWidth > maxTabWidth) {
        maxTabWidth = tabWidth;
      }
    }
  });

  return Math.min(maxTabWidth + 100, 500);
});

const emailsColumnWidth = computed(() => {
  let maxTabWidth = 0;

  members.value.forEach((row) => {
    const tabWidth = row.emails
      .map((email) => (email ? email.length * 12 : 0))
      .reduce((a, b) => a + b, 0);

    if (tabWidth > maxTabWidth) {
      maxTabWidth = tabWidth > 300 ? 300 : tabWidth;
    }
  });

  return maxTabWidth;
});

const selectedRows = computed(() => selectedMembers.value);
const pagination = computed({
  get() {
    return props.pagination;
  },
  set(value) {
    emit('update:pagination', value);
  },
});

const tableWidth = ref(0);

document.onmouseup = () => {
  // As soon as mouse is released, set scrollbar visibility
  // according to wether the mouse is hovering the table or not
  isScrollbarVisible.value = isTableHovered.value;
  isCursorDown.value = false;
};

const setActionBtnsRef = (el, id) => {
  if (el) {
    actionBtnRefs.value[id] = el;
  }
};

const onActionBtnClick = (member) => {
  if (selectedActionMember.value?.id === member.id) {
    showMemberDropdownPopover.value = false;

    setTimeout(() => {
      selectedActionMember.value = null;
    }, 200);
  } else {
    showMemberDropdownPopover.value = true;
    selectedActionMember.value = member;
  }
};

const setEnrichmentAttributesRef = (el, id) => {
  if (el) {
    enrichmentRefs.value[id] = el;
  }
};

const handleCellMouseEnter = (row, column) => {
  const validValues = ['reach', 'seniorityLevel', 'programmingLanguages', 'skills'];

  if (validValues.includes(column.property)) {
    showEnrichmentPopover.value = true;
    selectedEnrichmentAttribute.value = `${row.id}-${column.property}`;
  }
};

const onColumnHeaderMouseOver = (id) => {
  showEnrichmentPopover.value = true;
  selectedEnrichmentAttribute.value = id;
};

const handleCellMouseLeave = (_row, column) => {
  const validValues = ['reach', 'seniorityLevel', 'programmingLanguages', 'skills'];

  if (!validValues.includes(column.property)) {
    closeEnrichmentPopover();
  }
};

const closeEnrichmentPopover = (ev) => {
  if (ev?.toElement?.id !== 'popover-content') {
    showEnrichmentPopover.value = false;

    setTimeout(() => {
      selectedEnrichmentAttribute.value = null;
    }, 100);
  }
};

const closeDropdown = () => {
  showMemberDropdownPopover.value = false;

  setTimeout(() => {
    selectedActionMember.value = null;
  }, 200);
};

const onClickOutside = (el) => {
  if (!el.target?.id.includes('buttonRef')) {
    closeDropdown();
  }
};

function handleEditTagsDialog(member) {
  isEditTagsDialogOpen.value = true;
  editTagMember.value = member;
}

function doChangeSort(sorter) {
  filters.value.order = {
    prop: sorter.prop,
    order: sorter.order,
  };
}

function doChangePaginationCurrentPage(currentPage) {
  emit('update:pagination', {
    ...pagination.value,
    page: currentPage,
  });
}

function doChangePaginationPageSize(pageSize) {
  emit('update:pagination', {
    page: 1,
    perPage: pageSize,
  });
}

function translate(key) {
  return i18n(key);
}

function rowClass({ row }) {
  const isSelected = selectedRows.value.find((r) => r.id === row.id) !== undefined;

  return isSelected ? 'is-selected' : '';
}

function onCtaClick() {
  router.push({
    path: '/integrations',
  });
}

function onSecondaryBtnClick() {
  router.push({
    name: 'memberCreate',
  });
}

// On custom scrollbar scroll, set the table scroll with the same value
const onCustomScrollbarScroll = ({ scrollLeft }) => {
  table.value.setScrollLeft(scrollLeft);
};

// On table body scroll, set the custom scrollbar scroll with the same value
const onTableBodyScroll = () => {
  scrollbarRef.value.setScrollLeft(tableBodyRef.value.scrollLeft);
};

// On table header scroll, set the custom scrollbar scroll with the same value
const onTableHeaderScroll = () => {
  scrollbarRef.value.setScrollLeft(tableHeaderRef.value.scrollLeft);
  table.value.setScrollLeft(tableHeaderRef.value.scrollLeft);
};

const onScrollMousedown = () => {
  isCursorDown.value = true;
};

const onTableMouseover = () => {
  isTableHovered.value = true;
  isScrollbarVisible.value = true;
};

const onTableMouseLeft = () => {
  isTableHovered.value = false;
  isScrollbarVisible.value = isCursorDown.value;
};

const trackEmailClick = () => {
  window.analytics?.track('Click Member Contact', {
    channel: 'Email',
  });
};

watch(table, (newValue) => {
  if (newValue) {
    tableWidth.value = table.value;
  }

  // Add scroll events to table, it's not possible to access it from 'el-table'
  // as the overflowed element is within it
  const tableBodyEl = document.querySelector(
    '#members-table .el-scrollbar__wrap',
  );
  const tableHeaderEl = document.querySelector(
    '#members-table .el-table__header-wrapper',
  );

  if (tableBodyEl) {
    tableBodyRef.value = tableBodyEl;
    tableBodyRef.value.addEventListener('scroll', onTableBodyScroll);
  }

  if (tableHeaderEl) {
    tableHeaderEl.style.overflow = 'auto';
    tableHeaderRef.value = tableHeaderEl;
    tableHeaderRef.value.addEventListener('scroll', onTableHeaderScroll);
  }
});

const doExport = () => MemberService.export({
  filter: savedFilterBody.value.filter,
  orderBy: savedFilterBody.value.orderBy,
  limit: totalMembers.value,
  offset: null,
});

onMounted(() => {
  if (store.state.integration.count === 0) {
    store.dispatch('integration/doFetch');
  }
});

// Remove listeners on unmount
onUnmounted(() => {
  tableBodyRef.value?.removeEventListener('scroll', onTableBodyScroll);
  tableHeaderRef.value?.removeEventListener('scroll', onTableHeaderScroll);
});
</script>

<script>
export default {
  name: 'AppMemberListTable',
};
</script>

<style lang="scss">
// Hide table header scrollbar
#members-table .el-table__header-wrapper {
  // IE, Edge and Firefox
  -ms-overflow-style: none;
  scrollbar-width: none;

  // Chrome, Safari and Opera
  &::-webkit-scrollbar {
    display: none;
  }
}
#members-table .el-table__cell:not(.el-table-column--selection) {
  padding: 0;
}

.el-table tbody .cell {
  display: block !important;
  @apply p-0;

  &,
  & > a {
    @apply h-full w-full flex items-center;
  }

  & > a {
    @apply px-2.5 py-2;
  }
}
.el-table__body {
  height: 1px;
}

.popover-dropdown {
  padding: 0.5rem !important;
  width: fit-content !important;
}
</style>
